;
;-----------------------------------------------------------------
;
;	Fjlkezel segdprogram - programok indtsa VT-DOS-ban
;
;-----------------------------------------------------------------
;


;
;
;	Kivlasztott fjl kiterjesztsnek vizsglata s vgrehajtsa, ha lehetsges
;	in:  HL - a kivlasztott fjl kiterjesztsre mutat
;	out:  A - hibakd
;
fk_exec:ld	de,extable		; DE a futtathat fjlkiterjesztsek tblzatra mutat
fk_ex0:	push	hl
	call	fk_cmp			; kiterjeszts ellenrzse
	pop	hl
	jr	z,fk_ex3		; ugrs, ha a kiterjesztst megtallta
	inc	de			; DE a tblzat kvetkez elemre mutat
	ld	a,(de)
	or	a
	jr	nz,fk_ex0		; ismtls, ha van mg bejegyzs a tblzatban
	ld	de,plugs		; DE a plugin-tblzat elejre mutat
fk_ex1:	ld	a,(de)			; A reg.= aktulis bejegyzs hossza
	or	a
	ret	z			; visszatrs, ha nincs tbb bejegyzs
	push	hl			; kivlasztott fjl kiterjesztsnek cme a verembe
	ld	l,a
	ld	h,000h
	add	hl,de
	ex	(sp),hl			; kvetkez bejegyzs kezdcme a verembe
	push	hl			; kivlasztott fjl kiterjesztsnek cme a verembe
	inc	de
	call	fk_cmp			; kiterjeszts ellenrzse
	pop	hl
	pop	bc
	jr	z,fk_ex2		; ugrs, ha a kiterjesztst megtallta
	ld	d,b			; DE= kvetkez bejegyzs kezdcme
	ld	e,c
	jr	fk_ex1			; ugrs a kvetkez bejegyzs vizsglatra
;
fk_ex2:	ld	b,d			; plugin tvonalnv-string cme BC-be
	ld	c,e
	ld	de,plgfunc		; DE a vgrehajtand rutin cmre mutat
fk_ex3:	push	bc			; tvonalnv-string cme a verembe
	push	de			; vgrehajtand rutin mutatjnak cme a verembe
	ld	hl,ldtext
	call	fk_msg			; "Program betltse..." szveg kirsa a kperny aljra
	ld	bc,00101h
	call	ed_doscpos		; konzol kurzorpozci a bal fels sarokba
	call	ed_doson_noclr		; VT-DOS kurzor bekapcsolsa
	pop	hl
	pop	bc
	ld	e,(hl)			; rutin cmnek betltse DE-be
	inc	hl
	ld	d,(hl)
	ex	de,hl			; rutincm HL-be
	jp	(hl)			; ugrs a programot betlt rutinra


;
;
;	Futtathat fjlkiterjesztsek tblzata
;
extable:
	.db	"COM"			; COM fjl beazonostshoz
	.dw	fk_comload
	.db	"BAT"			; BAT fjl beazonostshoz
	.dw	fk_batload
	.db	000h			; tblzatot zr nulla bjt


;
;
;	Rutincm plugin program indtshoz
;	
plgfunc	.dw	fk_plugload



;
;
;	A kurzor alatti kivlasztott fjlnak megfelel plugin indtsa
;	in:  BC - a plugin program tvonalra mutat
;	out: -
;
fk_plugload:
	ld	h,b			; tvonalnv-string cme HL-be
	ld	l,c
	ld	c,000h			; fjlnv flag: fjlnv msolsa az FCB-be
	ld	de,FCB_0		; DE az inicializland FCB-re mutat
	ld	a,001h			; parancskd: tvonalnv-string elemzse
	call	fk_fish			; FISH funkci hvsa
	or	a
	jr	nz,fk_plg0		; ugrs, ha hiba trtnt
	bit	4,b			; visszatrsi jelzbitek vizsglata
	jr	z,fk_plg0		; ugrs, ha nem fjlnvkiterjeszts az utols elem
	push	hl
	ld	de,extable		; DE a "COM" szvegre mutat
	ld	hl,FCB_0 + 010h		; HL a plugin kiterjesztsre mutat
	call	fk_cmp			; kiterjeszts ellenrzse
	pop	hl
	jp	nz,fk_plg0		; ugrs, ha nem "COM" program
	call	pathcp0			; plugin tvonalnak tmsolsa a string bufferbe
	ld	a,(FCB_0 + 007h)	; A reg.= meghajtsorszm az FCB-bl
	ld	d,a			; sorszm D-be
	push	de			; meghajtszm a verembe is
	call	fk_setpath_sbuff	; plugin tvonalnak belltsa, sajt hibakezel rutin kikapcsolsa
	ld	bc,FCB_0 + 008h		; BC a plugin fjlnevre mutat a FCB0-ban
	jp	fk_bat0			; a folytats megegyezik a BAT fjl indtsval
;
fk_plg0:ld	a,0FFh			; hibakd belltsa
	jp	fk_loaderr2		; ugrs a hibakezelsre


;
;
;	A kurzor alatti kivlasztott BAT fjl indtsa
;	in:  -
;	out: -
;
fk_batload:
	ld	b,000h			; B= vltoz rtknek olvassa lesz
	ld	e,020h			; E= BOOT_DRV vltoz sorszma
	ld	a,01Ah			; parancskd: rendszervltoz beolvassa
	call	fk_fish			; FISH funkci hvsa
	push	de			; meghajtszm a verembe is
	ld	hl,strbuff
	ld	(hl),92			; gykrknyvtr belltsa: '\'
	inc	hl
	ld	(hl),000h
	call	fk_setpath_sbuff	; COMMAND.COM tvonalnak belltsa, sajt hibakezel rutin kikapcsolsa
	ld	bc,cmdname		; BC= betltend program neve

;
;	Program indtsa paramterrel
;
fk_bat0:push	bc			; programnv a verembe
	ld	hl,0005Ch
fk_bat1:ld	(hl),h			; U0 kinullzsa az 005Ch cmtl 00FFh-ig
	inc	l
	jr	nz,fk_bat1
	ld	a,(xaktbj)
	call	fk_fadr			; aktulis bejegyzs cme HL-be
	ld	de,0005Dh		; DE a 005Ch cmen kezdd CP/M FCB fjlnevre mutat
	ld	bc,0000Bh
	ldir				; fjlnv tmsolsa
	ld	hl,0006Dh		; HL a 006Ch cmen kezdd CP/M FCB fjlnevre mutat
	ld	(hl),020h
	ld	e,06Eh
	ld	c,00Ah			; fjlnv kitltse SPACE karakterekkel
	ldir
	ld	l,05Dh			; HL a 8+3-as fjlnvre mutat
	ld	e,082h			; fjlnv bemsolsa a paramtersorba
	call	fk_nam0
	ld	a,e
	sub	081h			; paramtersor hossznak kiszmtsa
	ld	(00080h),a
	ld	a,020h
	ld	(00081h),a		; bevezet szkz elhelyezse
	pop	bc			; BC= betltend program neve
	call	fk_memalloc		; memria lefoglalsa, rezidens kd s adatok tmsolsa
	pop	bc
	ld	a,b			; A reg.= meghajt sorszma
	dec	a			; meghajtszm cskkentse (0 -> A  1-> B ...)
	ld	(0004h),a		; meghajt sorszm trolsa
	ld	hl,0000h
	ld	(0003Eh),hl		; programbetltsi tvonal cmnek belltsa
	ld	l,082h
	ld	(00040h),hl		; parancsparamter string cmnek belltsa
;
	jp	fk_startload


;
;	Fjlnv a COMMAND.COM betltshez
;
cmdname	.db	"COMMAND COM"


;
;
;	A kurzor alatti kivlasztott COM fjl indtsa
;	in:  -
;	out: -
;
fk_comload:
	call	fk_setpath		; aktulis tvonal belltsa, sajt hibakezel rutin kikapcsolsa
	ld	hl,0005Ch
fk_cld0:ld	(hl),h			; U0 kinullzsa az 005Ch cmtl 00FFh-ig
	inc	l
	jr	nz,fk_cld0
	ld	l,05Dh			; HL a 005Ch cmen kezdd CP/M FCB fjlnevre mutat
	ld	(hl),020h
	ld	d,h
	ld	e,05Eh
	ld	bc,0000Ah		; fjlnv kitltse SPACE karakterekkel
	ldir
	ld	l,05Dh
	ld	e,06Dh			; DE a 006Ch cmen kezdd CP/M FCB fjlnevre mutat
	ld	c,00Bh			; fjlnv kitltse SPACE karakterekkel
	ldir
	ld	a,(xaktbj)
	call	fk_fadr			; aktulis bejegyzs cme HL-be
	ld	b,h			; BC= betltend program neve
	ld	c,l
	call	fk_memalloc		; memria lefoglalsa, rezidens kd s adatok tmsolsa
	ld	(0003Eh),hl		; programbetltsi tvonal cmnek belltsa
	ld	a,(hl)			; A reg.= meghajt betjele
	sub	'A'			; betbl meghajtszm (0-> A  1-> B ...)
	ld	(0004h),a		; meghajt sorszm trolsa
	ld	hl,0000h
	ld	(00040h),hl		; parancsparamter string cmnek belltsa

;
;
;	Program betltse s elindtsa
;	in:   A - az indtand program meghajtja (0-> A  1-> B ...)
;	     DE - lefoglalt memriaterlet kezdete
;	out: -
;
fk_startload:
	push	de			; lefoglalt terlet cme a verembe
	ld	hl,-025h
	add	hl,de
	ex	de,hl			; DE= kitlttt FCB elejre mutat
	push	de
	inc	a			; meghajtsorszm nvelse
	ld	(de),a			; meghajtsorszm bersa az FCB-be
	ld	c,00Fh			; C = funkcikd: fjl megnyitsa
	call	00005h			; VT-DOS hvsa
	pop	bc
	pop	de			; DE= lefoglalt memriaterlet kezdete
	or	a
	jr	nz,fk_loaderr1		; ugrs, ha hiba volt
	ld	hl,00013h
	add	hl,bc			; HL a fjlmret legfels bjtjra mutat
	ld	a,(hl)
	dec	hl
	or	(hl)
	ld	a,08Ch			; .NORAM hibajelzs
	jr	nz,fk_loaderr1		; ugrs, ha fjl nagyobb 64kB-nl
	dec	hl
	ld	b,(hl)			; BC= olvasand bjtok szma
	dec	hl
	ld	c,(hl)
	dec	h			; HL= a j TPA terlet szmolt teteje - 0100h (prog. kezdete) - 030h (az FCB mrete)
	ld	l,0D0h
	sbc	hl,bc
	jr	c,fk_loaderr1		; ugrs, ha a fjl nem fr a memriba
	push	de
	push	bc
	ld	a,(00080h)		; paramtersor vizsglata
	or	a
	call	nz,fk_setpath		; ha van paramter, akkor a megadott fjl tvonalnak belltsa
	pop	bc
	pop	de
;
	ld	(spcopy),sp		; aktulis veremmutat mentse arra az esetre, ha nem sikerlne a betlts
	ld	sp,0100h		; az j verem U0 RAM elejre kerl
	ld	hl,fk_res0 - fk_res
	add	hl,de			; HL= fk_res0 cme (ez lesz az j UIOS meleg indts vektor)
	push	hl			; cm a verembe
	ld	a,h
	ld	hl,00005h		; VT-BDOS indtsi cme
	ld	(hl),0C3h		; JP NNNN kdja
	inc	hl
	ld	(hl),006h
	inc	hl
	ld	(hl),a			; j vektor belltsa
;
	ld	hl,fk_res2 - fk_res
	add	hl,de
	push	hl			; indt rutin cme, sikeres betlts esetn
;
	ld	hl,fk_loaderror
	push	hl			; hibakezel rutin cme, hiba esetre
;
	ld	hl,fk_res1 - fk_res
	add	hl,de
	push	hl			; belpsi pont cme betltshez
;
	ld	hl,-025h
	add	hl,de
	ex	de,hl			; DE= a megnyitott FCB elejre mutat
	ret				; ugrs a rezidens programra (fk_res1 -re)

;
;
;	Hiba esetn ide tr vissza
;
fk_loaderror:
	pop	hl			; indt rutin cmnek kivtele
	pop	de			; HL= fk_res0 cme
	ld	sp,(spcopy)		; rgi veremmutat rtk vissza

fk_loaderr1:
	ex	de,hl
	ld	l,000h			; HL= ltrehozott TPA tet cme
	ld	bc,res_hossz
	add	hl,bc
	ld	de,00000h
	ld	bc,00013h
	ldir				; programfejlc visszalltsa
	ld	de,0003Ch
	ld	c,020h
	ldir				; programfejlc tovbbi rszeinek visszalltsa

fk_loaderr2:
	push	af			; hibakd mentse
	call	ed_dosoff_noclr		; kurzor kikapcsolsa
	ld	hl,fk_err_handler	; HL= belltand cm
	call	fk_set_errhand		; hibakezel rutin belltsa
	pop	af			; hibakd vissza
	or	a
	ret				; visszatrs a fjlkezel fciklusba


;
;
;	Visszatlts utn lefut rutin
;
fk_comback:
	pop	hl			; lementett vltozk kezdcme HL-be
	ld	sp,07FF0h		; j veremterlet kialaktsa U1 tetejn
	ld	a,(hl)			; A reg. = aktv videmd (0-> 2-szn  1-> 4-szn)
	ld	(stmod),a		; indulsi videmd belltsa
	inc	hl
	ld	a,(hl)			; rendezsi md A reg.-be
	ld	(sorttype),a		; vltoz belltsa
	inc	hl
	ld	de,path_ptr
	ldi				; aktv tvonal mutatjnak helyrelltsa
	ldi
	ld	de,pathbuff1
	ld	bc,00086h		; BC= 2 * 67 bjt, a kt panel tvonal-stringjnek hossza
	ldir				; tvonalstringek helyrelltsa
	ld	a,0FFh
	ld	(00080h),a		; melegindts jelzse a parancssor hosszbjtjn is
;
	JMP_WARMSTART			; ugrs a program melegindtsi pontjra
;



;
;
;	Memria lefoglalsa, rezidens kd s adatok tmsolsa
;	in:  BC - az FCB-be rand 8+3-as fjlnv
;	out: DE - lefoglalt memriaterlet kezdete
;	     HL - elmentett aktv tvonal kezdcme
;
fk_memalloc:
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a		; msolat a memrialapozsrl
	out	(002h),a		; memrialapozs belltsa
	ld	hl,(0006h)		; TPA terlet fels hatrnak meghatrozsa
	ld	(fk_res + 0007h),hl	; eredeti hatr-cm a sajt TPA tet ugrsi utastsba
	ld	l,000h
	ld	de,192 + res_hossz	; DE= elmentett adatok + rezidens programrsz hossza
	or	a
	sbc	hl,de			; hely lefoglalsa a rezidens programnak a TPA tetejn
	ld	l,000h			; HL igaztsa 256 bjtos laphatrra
	push	hl			; HL a verembe, a betltend program TPA terletnek ez lesz a fels hatra
;
	ld	de,-025h
	add	hl,de			; HL= kitltend FCB elejre mutat
	ld	(hl),000h		; meghajt szm: implicit meghajt
	inc	hl
	ex	de,hl
	ld	h,b
	ld	l,c
	ld	bc,0000Bh		; 8+3 bjtos fjlnv tmsolsa
	ldir
	ld	h,d
	ld	l,e
	ld	(hl),000h
	inc	de
	ld	c,018h			; htralv bjtok trlse
	ldir
;
	ld	hl,fk_res
	ld	bc,res_hossz
	ldir				; rezidens programrsz tmsolsa
	ld	hl,00000h
	ld	bc,00013h
	ldir				; programfejlc mentse
	ld	l,03Ch
	ld	c,020h
	ldir				; programfejlc tovbbi rszeinek mentse
	ld	hl,(00001h)		; HL= UIOS meleg indts vektor cme
	ldi				; vektor lementse
	ldi
	ldi
	ld	a,IY_GRMODE		; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa
	ld	(de),a			; aktv videmd mentse
	inc	de
	ld	a,(sorttype)		; rendezsi md A reg.-be
	ld	(de),a			; rendezsi md mentse
	inc	de
	ld	hl,path_ptr
	ldi				; aktv tvonal mutatjnak mentse
	ldi
	push	de			; programbetltsi tvonalak cme a verembe
	ld	hl,pathbuff1
	ld	bc,00086h		; BC= 2 * 67 bjt, a kt panel tvonal-stringjnek hossza
	ldir				; tvonalstringek elmentse
	ld	bc,pathbuff1		; aktulis tvonal beazonostsa
	ld	hl,(path_ptr)
	or	a
	sbc	hl,bc
	pop	hl			; HL= programbetltsi tvonalak msolatnak cme
	pop	de			; DE= lefoglalt memriaterlet kezdete
	ret	z			; visszatrs, ha az 1. tvonal az aktv
	ld	bc,67
	add	hl,bc
	ret



;
;
;	Memria-rezidens kd a betltshez, indtshoz s visszatltshez
;
;	megj.: a rezidens program csak DOS hvsokat tartalmazhat, mert a
;	       FISH nem hvhat U3 RAM terletn elhelyezett veremmel s/vagy FCB-kkel
;

fk_res:
	.db	000h, 016h, 000h, 000h, 000h, 000h, 0C3h, 062h	; CP/M verziszm s BDOS belpsi vektor
	.db	0EEh, 000h, 000h, 000h, 000h, 000h, 000h, 000h
;
	.db	"SDC     COM"		; sajt programnv a visszatltshez (11 bjt)


;
;
;	Belpsi pont visszatltskor
;
;
fk_res0:ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a
	out	(002h),a		; felhasznli lapozs belltsa
	ld	hl,(0006h)		; TPA terlet fels hatrnak meghatrozsa (visszatltskor)
	ld	l,000h
	ld	d,h			; DE= az FCB-be berand 8+3-as sajt fjlnvre mutat
	ld	e,010h
	ld	bc,00025h
	or	a
	sbc	hl,bc			; hely biztosts a DOS tpus FCB-nek
	ld	sp,0100h		; az j verem U0 RAM elejre kerl
	push	hl
	push	de
	ld	bc,res_hossz
	ld	h,d
	ld	l,000h
	add	hl,bc
	ld	de,00000h
	ld	bc,00013h
	ldir				; programfejlc visszalltsa
	ld	e,03Ch
	ld	c,020h
	ldir				; programfejlc tovbbi rszeinek visszalltsa
	ld	de,(00001h)		; DE= UIOS meleg indts vektor cme
	ldi				; vektor helyrelltsa
	ldi
	ldi
	push	hl			; HL= lementett vltozk kezdcme
;
	ld	hl,(0003Eh)		; HL= betltsi tvonal
	push	hl
	ld	a,(hl)			; A reg.= meghajt betjele
	sub	040h			; betjelbl meghajtsorszm (A->1  B->2 stb.)
	ld	d,a			; D= berand j adat
	ld	b,0FFh			; B= vltoz rtknek rsa lesz
	ld	e,021h			; E= DEF_UNIT vltoz sorszma
	ld	a,01Ah			; parancskd: rendszervltoz belltsa
	rst	08h			; FISH funkci hvsa
	pop	hl			; HL= betltsi tvonal
	ld	de,08000h		; itt taln nem zavar senkit
	ld	bc,00043h		; 67 bjtnl biztosan nem hosszabb
	ldir				; tvonal tmsolsa az U2 RAM elejre
	ld	hl,08000h		; HL az tvonal elejre mutat
	ld	a,002h			; parancskd: knyvtr-vltoztats
	rst	08h			; FISH funkci hvsa
;
	pop	bc			; BC= lementett vltozk kezdcme
	pop	de			; DE= az FCB-be berand 8+3-as sajt fjlnvre mutat
	pop	hl			; HL= FCB eleje
;
	push	bc			; lementett vltozk kezdcme a verembe
	ld	bc,fk_comback		; sikeres programvisszatlts utni ugrsi cm elhelyezse a verembe
	push	bc
	ld	bc,00000h		; visszatrsi cm lemezes hiba esetre
	push	bc
;	
	push	hl			; FCB kitltse
	ld	(hl),000h		; meghajt szm: implicit meghajt
	inc	hl
	ex	de,hl
	ld	bc,0000Bh		; 8+3 bjtos fjlnv tmsolsa
	ldir
	ld	h,d
	ld	l,e
	ld	(hl),000h
	inc	de
	ld	c,018h			; htralv bjtok trlse
	ldir
	pop	de			; DE= hasznlatlan FCB (aminek megfelel fjlt keres)
	push	de
	ld	c,00Fh			; C = funkcikd: fjl megnyitsa
	call	00005h			; VT-DOS hvsa
	pop	de
	or	a
	ret	nz			; visszatrs, ha hiba volt
	ld	hl,00011h
	add	hl,de			; HL a fjlmret msodik bjtjra mutat
	ld	b,(hl)			; olvasand bjtok szma BC-be
	dec	hl
	ld	c,(hl)

;
;
;	Belpsi pont az indtand program betltsekor
;	in:  BC - olvasand bjtok szma
;	     DE - a megnyitott FCB elejre mutat
;
fk_res1:push	bc
	push	de
	ld	de,00100h		; DE a program betltsi cmre mutat
	ld	c,01Ah			; C = funkcikd: diszk tviteli cm belltsa
	call	0005h			; VT-DOS hvsa
	pop	de
	ld	hl,000Eh		; HL= rekordmret cme az FCB-ben
	add	hl,de
	ld	(hl),001h		; rekordmret belltsa 1 bjtra
	inc	hl
	ld	(hl),000h
	pop	hl			; HL= olvasand bjtok szma
	ld	c,027h			; C = funkcikd: blokk olvassa
	call	0005h			; VT-DOS hvsa
	pop	bc			; hibakezelsi cm kivtele a verembl
	or	a
	ret	z			; ugrs a sikeres betlts esetre megadott cmre
	push	bc			; hibakezelsi cm vissza
	ld	b,a			; hibakd mentse
	ld	a,h
	or	l
	ld	a,b			; hibakd vissza
	ret	z			; ha nem olvasott egy bjtot sem, akkor mg vissza lehet trni
	rst	00h			; egybknt csak meleg reset lehetsges


;
;
;	Program indtsa sikeres betlts esetn
;
fk_res2:ld	hl,(00001h)		; HL= UIOS meleg indts vektor cme
	inc	hl
	pop	de			; DE= fk_res0 msolsi cme
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	h,d
	ld	l,000h
	ld	sp,hl			; j veremmutat kzvetlenl a TPA tet al
	ld	hl,000D8h
fk_res3:ld	(hl),h			; U0 kinullzsa az 00D8h cmtl 00FFh-ig
	inc	l
	jr	nz,fk_res3
	ld	de,00080h
	ld	c,01Ah			; C= funkcikd: diszk tviteli cm belltsa
	call	0005h			; VT-DOS hvsa
;
	xor	a
	out	(060h),a		; 0. paletta regiszter blltsa
	out	(061h),a		; 1. paletta regiszter blltsa
	out	(062h),a		; 2. paletta regiszter blltsa
	out	(063h),a		; 3. paletta regiszter blltsa
	ld	a,090h			; memrialapozs: U0, U1, VID, U3
	ld	hl,08000h
	ld	de,08001h
	ld	bc,03BFFh
	di
	out	(002h),a		; lapozs a porton
	ld	(hl),000h
	ldir				; kperny trlse (a konzol trl rutinja bugos)
	ld	a,(0003Bh)		; felhasznli lapozs vissza
	out	(002h),a
	ei
	ld	a,080h			; port 6-ba rand rtk: 7.- nyomtat (nSTROBE)  5..2 - hang amplitd  1..0 - grafikus md
	out	(006h),a		; 2-szn zemmd belltsa
	ld	a,050h
	out	(061h),a		; paletta regiszterek: 0-fekete, 1-zld
	ld	hl,0000h
	push	hl			; visszatrsi cm belltsa 0000h-ra
	ld	de,0E1FFh		; DE= 0E1FFh
	ld	bc,000FFh		; BC= 000FFh
	jp	00100h			; ugrs a betlttt program kezdetre
;


res_hossz	.equ	$ - fk_res


.end