;
;-----------------------------------------------------------------
;
;	Fjlkezel segdprogram
;
;-----------------------------------------------------------------
;

;
;-----------------------------------------------------------------
;	Fjlmanipulcis funkcik
;-----------------------------------------------------------------
;

;
;	Szvegek kezdcmei megersts krshez s a funkci nevnek kirshoz
;
megmsg	.dw	bnevez, bmasol, bhelyez, bkonyvt, btorol
funnev	.dw	fnevez, fmasol, fhelyez, fkonyvt, ftorol, fhelyez


;
;	Fjlkezelsi funkcik
;	in:   A - funkcit kivlaszt billenty ASCII kdja
;	     ZF - ZF=1 -> A= trls funkci (CP 007h miatt)
;	out:  A - hibakd
;
fk_func:ld	c,004h			; C= trls funkc kd
	jr	z,fk_fun0		; ugrs, ha tnyleg az van
	sub	'4'
	ld	c,a			; tbbi funkc kdja 0..3 kz konvertlva
fk_fun0:ld	a,c
	ld	(fmanid),a		; funkcikd mentse
	rlc	c			; C= C*2
	ld	b,000h
	ld	hl,megmsg
	add	hl,bc			; HL-ben az aktulis funkcinak megfelel zenettmb mutatjnak cme
	ld	a,(hl)
	inc	hl
	ld	h,(hl)			; HL az zenettmbre mutat
	ld	l,a
;
	CALL_FKPMSG			; zenet kirsa az als sorba
;
	call	fk_kerd			; krds, s vrakozs a vlaszra
	ld	a,092h			; .CTRLC - megszaktottk a parancs vgrehajtst (CLI hibakd)
	ret	nz			; visszatrs, ha a mgsem-et vlasztottk
	ld	a,(fmanid)		; funkcikd vissza A reg.-be
	cp	3
	jr	nc,fk_fun1		; ugrs, ha trls vagy j knyvtr
	or	a
	jr	z,fk_fun1		; ugrs, ha tnevezs
	ld	de,pathbuff1		; cl tvonalmutat belltsa thelyezs s msols esetn
	ld	hl,(path_ptr)
	sbc	hl,de
	jr	nz,fk_fund		; ugrs, ha pathbuff1 a cl tvonal
	ld	de,pathbuff2
fk_fund:ld	(dest_ptr),de		; clmutat belltsa
	ld	c,a
	ld	a,(pathbuff1)		; tvonalak ellenrzse
	ld	b,a			; az 1. tvonal meghajtjele B-be is
	or	a
	jp	z,fk_fun7		; ha brmelyik tvonal a meghajt lista, akkor hiba
	ld	a,(pathbuff2)
	or	a
	jp	z,fk_fun7		; ugrs, ha a 2. tvonal a meghajt lista
	dec	c
	jr	z,fk_fun2		; ugrs, ha msols a vlasztott funkci
	cp	b
	jr	z,fk_fun2		; ugrs, ha thelyezsnl a forrs s cl meghajt megegyezik
	ld	a,005h			; egybknt az thelyezs= msols + trls
	ld	(fmanid),a		; funkcikd mentse
	jr	fk_fun2
;
fk_fun1:ld	hl,(path_ptr)		; aktulis tvonal ellenrzse j knyvtr, tnevezs s trls esetn
	ld	a,(hl)
	or	a
	jp	z,fk_fun7		; ugrs, ha az aktulis tvonal a meghajt lista
fk_fun2:ld	c,0			; GRAPHICS 2 belltsa, kperny trlse
	call	ed_vidmode
	ld	a,(fmanid)		; funkcikd A reg.-be
	add	a,a			; A reg.*2
	ld	c,a
	ld	b,000h
	ld	hl,funnev
	add	hl,bc			; HL a funnev tmbben a funkcinv cmre mutat
	ld	a,(hl)
	inc	hl
	ld	h,(hl)			; HL a rsz-stringekbl ll funkcinvre mutat
	ld	l,a
;
	CALL_UT_PRNT			; funkcinv kirsa az aktulis karakterpozciba
;
	ld	a,(fmanid)		; funkcikd ismt A reg.-be
	cp	3
	jp	z,fk_ndir		; ugrs, ha j knyvtr ltrehozsa (ezt csak egy fjlon lehet vgrehajtani)
	or	a
	jr	nz,fk_fun3		; ugrs, ha nem tnevezs
	call	fk_nvbe			; j fjlnv beolvassa, elksztse FCB0-ban
	ret	nz			; visszatrs, ha hiba volt
	ret	c			; visszatrs, ha ESC-et nyomtak
;
fk_fun3:ld	a,001h
	ld	(rec_level),a		; rekurzis szint alaphelyzetbe
	ld	a,(nselect)
	or	a
	jp	z,fk_fun5		; ugrs, ha egy fjl sincs kivlasztva (a kurzor alattin vgzi el a mveletet)
	ld	a,(nbj)
	ld	b,a			; az sszes bejegyzs vizsglata a kijelltek megkeresshez
	ld	c,000h			; C-ben a rendez buffer-beli index
fk_fun4:ld	a,c
;
	CALL_FKFADR
;
	ld	de,11
	add	hl,de			; HL a bejegyzs attribtumra mutat
	ld	a,(hl)
	sbc	hl,de
	and	080h
	push	bc
	call	nz,fk_fun8		; fjlmvelet elvgzse, ha ki van jellve
	pop	bc
	or	a			; volt hiba?
	jp	nz,fk_fun6		; ugrs, ha igen
	inc	c			; index nvelse
	djnz	fk_fun4
	xor	a			; hiba trlse, CY=0
	ret

;
;
;	Kivlasztott mvelet elvgzse a kurzor alatti fjlon
;
fk_fun5:ld	a,(xaktbj)		; kurzor alatti fjlnv indexe
;
	CALL_FKFADR			; HL= fjl bejegyzsnek cme
;
	call	fk_fun8			; folytats a mvelet vgrehajtsval
	or	a
	ret	z			; visszatrs, ha nem volt hiba
;
fk_fun6:				; hibakezels
	ret


;
;	Hibakd-bellts tvonalellenrzsek utn
;
fk_fun7:ld	a,089h			; .IPSTR - hibs cl vagy forrs tvonal (CLI hibakd)
	or	a
	ret



;
;
;	Forrsfjl kikeresse nv alapjn, majd elgazs a vlasztott fjlmvelet szerint
;	in:  HL - fjl 8+3 karakteres nevre mutat
;	out:  A - hibakd
;
fk_fun8:push	hl			; fjlnv cmnek mentse
	call	fk_pcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
	pop	hl
;
	CALL_FKFRST			; els keresse
;
	or	a			; volt hiba?
	ret	nz			; visszatrs ha igen
;
;
;	Elgazs a kivlasztott fjlmvelet alapjn, eltte forrsfjl nevnek kirsa
;
fk_fun9:ld	a,(FCB_0 + 8)		; A reg.= tallt fjlnv els karaktere
	cp	'.'
	jr	nz,fk_fu11		; ugrs, ha nem "." vagy ".."
	ld	a,(FCB_0 + 9)		; msodik karakter vizsglata
	cp	020h			; ez az aktulis knyvtr jelzse lehet?
	jr	z,fk_fu10		; ugrs, ha igen
	cp	'.'
	jr	nz,fk_fu11		; ugrs, biztosan nem "." vagy ".."
fk_fu10:ld	a,(FCB_0 + 19)		; az attribtum ellenrzse
	and	10h
	xor	10h			; hibajelzs trlse
	ret	z			; visszatr, ha tnyleg rendszer-knyvtrbejegyzs
fk_fu11:ld	hl,FCB_0 + 8		; HL a tallt fjlnvre mutat
;
	CALL_FKNAME			; fjlnv kirsi formtum elksztse
;
	CALL_UT_LNF			; soremels
;
	ld	hl,fnamebuff		; fjlnv kirsa 
	ld	a,(rec_level)		; A reg.= rekurzis szint
	rlca				; szorzs 2-vel
	ld	b,a			; X karakter pozci a rekurzis szintnek megfelel
	ld	c,00h			; Y karakter pozci az aktulis
	ld	a,(FCB_0 + 19)		; az attribtum ellenrzse
	and	10h
	jr	z,fk_fu12		; ugrs, ha nem alknyvtr
	ld	a,92			; '\'
	dec	hl
	ld	(hl),a			; visszaper kirsa a nv el
fk_fu12:
;
	CALL_UT_PRN0
	ld	a,(fmanid)		; funkcikd A reg.-be
	or	a			; 0.- tnevezs
	jr	z,fk_move
	dec	a			; 1.- tmsols
	jp	z,fk_copy
	dec	a			; 2.- thelyezs
	jr	z,fk_move
	dec	a			; 3.- j knyvtr (itt tlpett funkci)
	dec	a			; 4.- trls
	jp	z,fk_del
	dec	a			; 5.- thelyezs msik meghajtra
	jr	z,fk_mdsk
	ret				; hiba esetn visszatr (A<>0)

;
;
;	thelyezs msik meghajtra
;	(FCB0 s FCB1 az els keress eredmnyt tartalmazza)
;	in:  -
;	out:  A - hibakd
;
fk_mdsk:call	fk_copy			; fjl msolsa a cl tvonalra
	or	a
	ret	nz
	call	fk_del			; fjl trlse a forrs tvonalon
	ret


;
;	Egy fjl tnevezse vagy thelyezse meghajtn bell
;	(FCB0 s FCB1 az els keress eredmnyt tartalmazza)
;	in:  -
;	out:  A - hibakd
;
fk_move:ld	hl,(dest_ptr)		; cl tvonalstring HL-be
	ld	a,(fmanid)		; funkcikd A reg.-be
	or	a			; 0.- tnevezs
	push	af			; ZF megrzse
	call	nz,fk_pcp0		; cl tvonal a strbuff-ba, ha thelyezs
	pop	af
	ld	bc,FCB_2		; BC= hasznlatlan FCB az j nvvel (tnevezs esetn)
	ld	de,FCB_0		; DE= tallt fjlbejegyzs meghatrozott FCB-je
	ld	hl,FCB_1		; HL= visszaadott keressi FCB
	ld	a,009h			; A = FISH funkci: tnevezs
	jr	z,fk_mov0
	inc	a			; A = FISH funkci: thelyezs
	ld	bc,strbuff		; BC= az j tvonalstringre mutat
fk_mov0:
	CALL_FKFISH			; FISH funkci hvsa
;
	ret


;
;	Egy fjl msolsa
;	(FCB0 s FCB1 a forrs els keress eredmnyt tartalmazza)
;	in:  -
;	out:  A - hibakd
;
fk_copy:ld	a,(L0BF2h + 1)		; A = CLI puffer mretnek fels bjtja
	and	0FEh			; puffermret lefel kerektse n*512 bjtra
	ld	a,08Ch			; hibakd: .NORAM - nincs elg memria
	ret	z			; visszatrs, ha a CLI puffer kisebb 512 bjtnl
	ld	a,(FCB_0 + 19)		; az attribtum ellenrzse
	and	10h
	jp	nz,fk_cop6		; ugrs, ha a forrs egy alknyvtr
	ld	hl,FCB_4		; FCB4 inicializlsa a ltrehozand fjl nevvel
	ld	(hl),0FFh		; hasznlatlan FCB jelzs
	ld	hl,FCB_4 + 6
	ld	(hl),000h		; keressi attributum (nem keres ktet azonostt)
	inc	hl
	ld	(hl),000h		; 0=aktulis meghajt (? az tvonalnvbl veszi a meghajtt)
	inc	hl
	ex	de,hl
	ld	hl,FCB_0 + 8		; HL a tallt a forrs fjlnvre mutat
	ld	bc,11			; 8+3 bjtos fjlnv tmsolsa
	ldir
	ld	de,FCB_0		; DE= tallt fjlbejegyzs meghatrozott FCB-je
	ld	hl,FCB_1		; HL= visszaadott keressi FCB
	ld	a,00Ch			; A = FISH funkci: fjl megnyitsa
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; volt hiba?
	ret	nz			; visszatrs ha igen
	ld	de,pathbuff1		; cl tvonalstring DE-be
	ld	hl,(path_ptr)
	sbc	hl,de
	jr	nz,fk_cop0		; ugrs, ha pathbuff1 a cl tvonal
	ld	de,pathbuff2
fk_cop0:ex	de,hl			; cl tvonal HL-be
	call	fk_pcp0			; cl tvonal a strbuff-ba
	ld	bc,FCB_3		; BC= hely a tallt FCB-nek
	ld	de,FCB_4		; DE= hasznlatlan FCB (aminek megfelel fjlt keres)
	ld	hl,strbuff		; HL= a cl tvonalstringre mutat
	ld	a,006h			; A = FISH funkci: fjl ltrehozsa
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; volt hiba?
	ret	nz			; visszatrs ha igen
	ld	de,FCB_3		; DE= tallt fjlbejegyzs meghatrozott FCB-je
	ld	hl,FCB_4		; HL= visszaadott keressi FCB
	ld	a,00Ch			; A = FISH funkci: fjl megnyitsa
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; volt hiba?
	ret	nz			; visszatrs ha igen
fk_cop1:ld	a,(L0BF2h +1)		; A = CLI puffer mretnek fels bjtja
	and	0FEh
	ld	b,a			; BC= tviteli hossz (n * 512 bjt)
	ld	c,000h
	ld	de,FCB_0		; DE= forrsfjl megnyitott FCB-je
	ld	ix,(L0BF0h)		; IX= CLI puffer kezdcme
	ld	a,00Fh			; A = FISH funkci: olvass fjlbl
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; volt hiba?
	jr	z,fk_cop2		; ugrs, ha nem
	cp	0ECh
	jr	nz,fk_cop3		; ugrs, ha nem .EOF hiba
fk_cop2:push	af			; hibakd mentse
	ld	de,FCB_3		; DE= clfjl megnyitott FCB-je
	ld	ix,(L0BF0h)		; IX= CLI puffer kezdcme
	ld	a,010h			; A = FISH funkci: rs fjlba
;
	CALL_FKFISH			; FISH funkci hvsa
;
	pop	bc			; olvass hibakdja (0 vagy .EOF) B-be
	or	a
	jr	nz,fk_cop3		; ugrs, ha rsnl volt hiba
	or	b
	jr	z,fk_cop1		; ugrs, ha mg nem rt a fjl vgre
	xor	a			; egybknt hibakd trlse
fk_cop3:push	af			; hibakd mentse
	ld	de,FCB_3		; DE= clfjl megnyitott FCB-je
	ld	a,00Dh			; A = FISH funkci: fjl lezrsa
;
	CALL_FKFISH			; FISH funkci hvsa
;
	ld	b,a
	pop	af			; korbbi hibakd vissza
	jr	nz,fk_cop4		; ugrs, ha korbban mr volt hiba
	or	b
	jr	z,fk_cop5		; ugrs, ha most sem volt hiba
fk_cop4:push	af			; hibakd mentse
	ld	de,FCB_3		; DE= clfjl meghatrozott FCB-je
	ld	hl,FCB_4		; HL= visszaadott keressi FCB
	ld	a,008h			; A = FISH funkci: fjl trlse
;
	CALL_FKFISH			; FISH funkci hvsa
;
	pop	af			; eredeti hibakd vissza
	ret				; visszatrs
;
fk_cop5:ld	a,(FCB_0 + 013h)	; A reg.= FCB0 +13h bjtja
	set	5,a			; 5.bit=1 (archivlsi attribtum bit)
	ld	(FCB_3 + 013h),a	; mdostott rtk bersa FCB3 +13h bjtjra
	ld	de,FCB_3 + 021h		; DE= FCB3 meghatrozott FCB-ben az utols mdosts dtuma
	ld	hl,FCB_0 + 01Ch		; HL= FCB0-ban a +01Ch bjtra mutat (nyitott FCB-ben az utols mdosts dtuma)
	push	hl			; cm mentse
	ldd				; 2 bjt msolsa FCB0-bl FCB3-ba (cm cskkentssel)
	ldd
	pop	hl
	inc	hl
	inc	hl			; HL FCB0-ban az utols mdosts idejre mutat
	ldd				; 2 bjt msolsa FCB0-bl FCB3-ba (cm cskkentssel)
	ldd
	ld	de,FCB_3		; DE= clfjl meghatrozott FCB-je
	ld	hl,FCB_4		; HL= visszaadott keressi FCB
	ld	a,00Bh			; A = FISH funkci: attribtumok vltoztatsa (+ dtum s id is)
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; volt hiba?
	ret	nz			; visszatrs ha igen
	ld	a,(FCB_4 + 007h)	; A reg.= FCB4-bl a meghajt azonost
	ld	b,a			; B= meghajt szma
	ld	c,000h			; C= 00h -> csak pufferek trlse lesz
	ld	a,00Eh			; A = FISH funkci: pufferek trlse
;
	CALL_FKFISH			; FISH funkci hvsa
;
	xor	a			; hibakd trlse
	ret				; visszatrs

;
;	Alknyvtr msolsa
;
fk_cop6:ld	hl,FCB_0 + 8		; aktulis tvonalstring bvtse a knyvtr nevvel
;
	CALL_FKDENT
;
	ld	a,000h
	ret	c			; visszatrs, ha 64 karakternl hoszabb lenne az tvonalstring
	call	pathcmp			; cl tvonal vizsglata, nehogy a forrs egy alknyvtra legyen
	jr	nz,fk_cop7		; ugrs, ha megfelel a cl tvonal
;
	CALL_FKDOUT			; aktulis tvonalstring visszalptetse
;
	ld	a,09Fh			; hibakd: .DIRE - rvnytelen knyvtr-thelyezs
	or	a
	ret
;
fk_cop7:ld	de,FCB_2		; FCB2 kitltse
	ld	hl,FCB_0 + 8		; HL a msoland alknyvtr nevre mutat
;
	CALL_FKFCB
;
	ld	hl,(dest_ptr)		; cl tvonalstring tmsolsa az U0 RAM-ba
	call	fk_pcp0
	call	fk_ndi0			; knyvtr ltrehozsa FCB2 alapjn
	ret	nz			; visszatrs, ha nem sikerlt
	ld	hl,FCB_0 + 8		; HL= az alknyvtr 8+3-as nevre mutat
	ld	de,(dest_ptr)		; DE= a bvtend tvonal cme
;
	CALL_FKDEN0			; cl tvonal bvtse
;
	ld	a,000h
	ret	c			; visszatrs, ha 64 karakternl hoszabb lenne az tvonalstring
	jp	fk_del3			; ugrs a rekurzis rutinra

;
;	Felhasznli megersts krse csak olvashat fjl
;	vagy nem res alknyvtr trlse eltt
;	in:  HL - zenet szvegnek cme (az "sdc_util" modulban)
;	out:  A - hibakd (00h)
;	     ZF - ZF=1 -> igen vlasz volt  ZF=0 -> elutastva
; 
fk_ask:	
;
	CALL_UT_PRNT			; zenet kirsa az aktulis karakterpozciba
;
	ld	l,000h			; 2-szn md jelzse
	call	fk_kerd			; krds, s vrakozs a vlaszra
	ld	a,000h			; hibakd elutasts esetre
	ret

;
;
;	Egy fjl trlse
;	(FCB0 s FCB1 az els keress eredmnyt tartalmazza)
;	in:  -
;	out:  A - hibakd
;
fk_del:	ld	de,FCB_0		; DE= tallt fjlbejegyzs meghatrozott FCB-je
	ld	hl,FCB_1		; HL= visszaadott keressi FCB
	ld	a,008h			; A = FISH funkci: trls
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a
	ret	z			; visszatrs, ha nem volt hiba
	cp	09Ah			; a fjl csak olvashat (.FILRO) ?
	jp	z,fk_del1		; ugrs, a megfelel felhasznli beavatkozsra
	cp	09Eh			; a trlend alknyvtr nem res (.DIRNE)?
	jp	z,fk_del2		; ugrs, a megfelel felhasznli beavatkozsra
	cp	0A7h			; rendszerknyvtr (.DOT) ?
	ret	nz			; visszatrs, ha nem
	xor	a			; egybknt hibajelzs trlse
	ret				; visszatrs
;
;
;	'Csak olvashat' fjl trlse
;
fk_del1:ld	hl,bfrdo		; figyelmeztets s krds feltevse
	call	fk_ask
	ret	nz			; visszatrs, ha 'nem' a vlasz
	ld	hl,FCB_0 + 19		; HL a meghatrozott FCB attribtumra mutat
	ld	a,(hl)
	res	0,a			; csak olvashat jelzs trlse
	ld	(hl),a
	ld	de,FCB_0		; DE= tallt fjlbejegyzs meghatrozott FCB-je
	ld	hl,FCB_1		; HL= visszaadott keressi FCB
	ld	a,00Bh			; A = FISH funkci: attribtumok vltoztatsa
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a
	ret	nz			; visszatrs, ha hiba volt
	ld	de,FCB_0		; DE= tallt fjlbejegyzs meghatrozott FCB-je
	ld	hl,FCB_1		; HL= visszaadott keressi FCB
	ld	a,008h			; A = FISH funkci: trls
;
	CALL_FKFISH			; FISH funkci hvsa
;
	ret
;
;
;	Egy teljes alknyvtr trlse rekurzi lehetsgvel
;
fk_del2:ld	hl,bdne			; figyelmeztets s krds feltevse
	call	fk_ask
	ret	nz			; visszatrs, ha 'nem' a vlasz
	ld	hl,FCB_0 + 8		; aktulis tvonalstring bvtse a knyvtr nevvel
;
	CALL_FKDENT
;
	ld	a,000h
	ret	c			; visszatrs, ha 64 karakternl hoszabb lenne az tvonalstring
fk_del3:ld	hl,rec_level		; rekurzis szint nvelse
	inc	(hl)
	call	fk_pcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
	ld	hl,fn_all		; HL a *.*-nak megfelel krdjelekre mutat (!!! IF krtynl ez msik ROM lapon van !!!)
;
	CALL_FKFRST			; els keresse
;
	jr	fk_del5			; ugrs a folytatsra
;
fk_del4:ld	bc,FCB_0		; BC= hely a tallt FCB-nek
	ld	de,FCB_1		; DE= keressi FCB (az els keressbl)
	ld	a,005h			; A = FISH funkci: kvetkez keresse
;
	CALL_FKFISH			; FISH funkci hvsa
;
fk_del5:ld	c,a
	cp	0A1h			; nincs tbb fjl (.NOFIL)?
	ld	a,000h			; hiba trlse
	jr	z,fk_del6		; ha nincs tbb fjl, ugrs a befejez mveletekre
	or	c			; volt egyb hiba? (hibakd vissza A reg.-be)
	jr	nz,fk_del6		; egyelre nem kezeli
	call	fk_fun9			; fjl trlse, eltte nv kirsa
	jr	fk_del4
;
fk_del6:ld	hl,rec_level		; rekurzis szint cskkentse
	dec	(hl)
	ld	a,(fmanid)		; funkcikd A reg.-be
	and	001h
	ld	hl,(dest_ptr)		; cl tvonalstring visszalptetse, ha msols vagy
	jr	z,fk_de10		; thelyezs msik meghajtra volt
;
	CALL_FKDOU0			; visszalptets
;
fk_de10:ld	hl,fnamebuff		; fjlnvpuffer kitltse SPACE karakterekkel
	ld	(hl),020h
	ld	de,fnamebuff+1
	ld	bc,10
	ldir
;
	CALL_FKDOUT			; aktulis tvonalstring visszalptetse egy knyvtrral feljebb
;
	ld	de,fnamebuff
	jr	nz,fk_del7		; ugrs, ha mg nem a gykrknyvtr
	ld	a,b			; els karakter visszarsa B-bl
	ld	(de),a
	inc	de
fk_del7:inc	hl			; HL a most kirtett alknyvtr nevre mutat
	ld	bc,0B2Eh		; max_hossz= 11  spec.kar= '.'
;
	CALL_FKSCPY			; alknyvtrnv msolsa
;
	jr	c,fk_del8		; ugrs, ha nem volt specilis karakter
	inc	hl			; HL a kiterjesztsre mutat
	ld	de,fnamebuff+8		; DE= cl
	ld	bc,0300h		; max_hossz= 3  spec.kar= 00h
;
	CALL_FKSCPY			; kiterjeszts msolsa
;
fk_del8:call	fk_pcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
	ld	hl,fnamebuff
;
	CALL_FKFRST			; alknyvtr nvbejegyzsnek keresse
;
	or	a
	ret	nz			; mi lesz ???
	ld	a,(fmanid)		; funkcikd A reg.-be
	dec	a
	jr	z,fk_del9		; ugrs, ha msols volt
	ld	de,FCB_0		; DE= tallt fjlbejegyzs meghatrozott FCB-je
	ld	hl,FCB_1		; HL= visszaadott keressi FCB
	ld	a,008h			; A = FISH funkci: trls
;
	CALL_FKFISH			; FISH funkci hvsa
;
	cp	09Eh			; a trlend alknyvtr nem res (.DIRNE)?
	jr	nz,fk_del9		; ugrs, ha nem .DIRNE hiba
	xor	a			; hiba trlse
fk_del9:ld	bc,10
	ld	de,FCB_1 + 9		; DE a fjlnv + 1 cmre mutat a keressi FCB-ben
	ld	hl,FCB_1 + 8		; HL a fjlnv elejre (bug: eredetileg fn_all-ra mutatott az SDC_LIB ROM-lapjn)
	ld	(hl),'?'
	ldir				; keressi fjlnv lecserlse a joker karakterekre
	ret

;
;
;	j knyvtr ltrehozsa
;	in:  -
;	out:  A - hibakd
;
fk_ndir:call	fk_nvbe			; knyvtrnv bekrse
	ret	nz			; visszatrs, ha hiba volt
	ret	c			; visszatrs, ha ESC-et nyomtak
	call	fk_pcpy			; aktulis tvonalstring tmsolsa az U0 RAM-ba
;
fk_ndi0:ld	bc,FCB_1		; BC= hely az FCB szmra
	ld	de,FCB_2		; DE= hasznlatlan FCB a knyvtrnvvel
	ld	hl,strbuff		; HL= az aktulis tvonalra mutat
	ld	a,007h			; A = FISH funkci: knyvtr ltrehozsa
;
	CALL_FKFISH			; FISH funkci hvsa
;
	or	a			; CY=0
	ret


;
;	Fjlnv/ knyvtrnv bekrse, ellenrzse s bemsolsa FCB2-be
;	in: -
;	out:  A - hibakd
;	     ZF - ZF=0 -> MOPS hiba trtnt
;	     CY - CY=1 -> ESC-et nyomtak (ha ZF=1)
;
;
fk_nvb0:ld	hl,rnevtxt		; hibaszveg kirsa, majd a nv ismtelt bekrse
;
	CALL_UT_PRNT			; kirs az aktulis karakterpozciba
;
fk_nvbe:call	fk_nnv			; nev beolvassa
	ret	nz			; visszatrs, ha hiba volt
	ret	c			; visszatrs, ha ESC-et nyomtak
	xor	a
	ld	(hl),a			; lezr nulla elhelyezse a string utn
	ld	hl,(path_ptr)
	ld	a,(hl)
	sub	040h			; karakterbl meghajt sorszm ksztse (A->1 B->2 ..)
	ld	c,a			; meghajt sorszm C-be
	ld	hl,FCB_2		; HL= FCB2-re mutat
	ld	(hl),0FFh		; hasznlatlan FCB jelzse
	ex	de,hl			; FCB2 cme DE-be
	ld	hl,0006h
	add	hl,de
	ld	(hl),000h		; keressi attribtum nullzsa
	inc	hl
	ld	(hl),c			; meghajtsorszm belltsa
	ld	c,000h			; C = 00h (fjlnv flag -> fjlnv msolsa az FCB-be)
	ld	hl,strbuff		; HL= a nv elejre mutat
	ld	a,001h			; A = FISH funkci: tvonalnv-string elemzse
;
	CALL_FKFISH			; FISH funkci hvsa
;
	ld	a,b
	and	018h			; visszatrsi jelzbitek ellenrzse
	jr	z,fk_nvb0		; ugrs, ha az utols elem nem fjlnv vagy fjlnv kiterjeszts (hiba: rvnytelen nv)
	xor	a
	ret

;
;	Nv beolvassa, bevezet szveggel
;	in: -
;	out: - ld. lentebb
;
fk_nnv:	ld	hl,fnevtxt
;
	CALL_UT_PRNT			; 'Nv:' szveg kirsa az aktulis karakterpozciba
;

;
;	Nv beolvassa a string bufferbe
;	in: -
;	out:  A - hibakd, ha ZF=0
;	     HL - a beolvasott karakterlnc utni bjtra mutat
;	     ZF - ZF=0 -> MOPS hiba trtnt
;	     CY - CY=1 -> ESC-et nyomtak (ha ZF=1)
;
fk_nev:	ld	bc,(kurzor_poz)		; BC= editor kurzorpozcija
	call	ed_doscpos		; konzol kurzorpozci a kirt szveg vgre lltva
	call	ed_doson_noclr		; VT-DOS kurzor bekapcsolsa (kpernytrls nlkl)
	ld	de,strbuff		; ide olvassa a begpelt karaktereket
	ld	a,00Ch
	ld	(de),a			; a puffer els bjtjra a beolvashat hossz (8 +3 +1)
	ld	c,00Ah			; funkcikd: pufferelt sor input
	call	0005h			; VT-DOS hvsa
	call	ed_dosoff_noclr		; VT-DOS kurzor kikapcsolsa (kpernytrls nlkl)
	ld	a,(strbuff+1)
	or	a			; beolvasott hossz ellenrzse
	scf
	ret	z			; visszatrs, ha nem rtak be nevet (CY=1)
	ld	b,a			; B= msoland karakterek max. szma
	ld	c,000h			; C= msolt karakterek szma
	ld	de,strbuff
	ld	hl,strbuff+2
fknev0:	ld	a,(hl)
	inc	hl
	inc	c
	dec	c
	jr	nz,fknev1		; ugrs, ha mr msolt karaktert
	cp	021h
	jr	c,fknev2		; ugrs, ha szkz vagy kisebb ASCII kd karakter
fknev1:	ld	(de),a
	inc	de
	inc	c
fknev2:	djnz	fknev0
	ex	de,hl			; HL az utols karakter utn mutat
	ld	a,c
	or	a
	scf				; CY=1 ha nem volt hasznos karakter
	ret	z
;
	CALL_UT_LNF			; soremels
;
	xor	a
	ret

;
;	Cl tvonal sszehasonltsa a forrs tvonallal
;	in: -
;	out: BC - megrzdik
;	     ZF - ZF=1 -> a cl tvonal megegyezik a forrssal vagy annak egy alknyvtra
;
pathcmp:ld	hl,(dest_ptr)		; HL= cl cme
	ld	de,(path_ptr)		; DE= forrs cme
pathcm1:ld	a,(de)
	cp	(hl)
	jr	nz,pathcm2		; ugrs, ha klnbznek a karakterek
	inc	hl
	inc	de
	or	a
	jr	nz,pathcm1		; ismtls, amg nem rt a stringek vgre
	ret				; ZF=1 -> a kt tvonalnv megegyezik
;
pathcm2:or	a
	ret	nz			; visszatrs, ha a forrs tvonalnv mg nem rt vget (nincs hiba)
	dec	de
	ld	a,(de)			; forrs megelz karakternek vizsglata
	cp	92			; sszehasonlts '\'-rel
	ret	z			; visszatrs, ha a forrs a gykrknyvtr (hiba)
	ld	a,(hl)			; a cl tvonalnv vizsglata a forrs tvonalnv vgnl
	cp	92			; sszehasonlts '\'-rel
	ret				; ha a cl adott karaktere '\': ZF=1 -> a cl a forrs egy alknyvtra


;
;	tvonal msolsa a string bufferbe
;	in:  HL - msoland tvonalstring (fk_pcp0-nl belpve)
;	out:    -
;
fk_pcpy:ld	hl,(path_ptr)		; aktulis tvonalstring tmsolsa az U0 RAM-ba
fk_pcp0:ld	de,strbuff
fk_pcp1:ld	a,(hl)
	ld	(de),a
	inc	hl
	inc	de
	or	a
	jr	nz,fk_pcp1		; msols a lezr nullig
	ret


;
;	Igen/nem krds feltevse
;	in:   L - grafikus md (0-> 2 szn  1-> 4 szn)
;	out: ZF - ZF=1 -> igen vlasz volt
;
fk_kerd:ld	c,'?'			; '?' kirsa az aktulis karakterpozciba
	call	ed_chout
	ld	a,l			; grafikusmd A reg.-be
	and	001h			; videmd maszkolsa
	jr	nz,fk_ker0		; ugrs, ha nem 2-szn md
	ld	hl,fkftxt
;
	CALL_UT_PRNT			; vlasztsi lehetsgek kirsa az aktulis karakterpozciba
;
fk_ker0:ld	c,008h			; vrakozs egy gomb lenyomsra (konzol input echo nlkl)
	call	0005h			; VT-DOS hvsa
	ld	c,'i'			; "igen" vlasz tesztelse
	cp	c
	ret	z
	ld	c,'I'			; nagybetre is
	cp	c
	ret


.end
